program TransLangCon11_lite;

  //  *************************************************************
  //  *     .mp3          *
  //  *  CD      ,  *
  //  *             *
  //  *   .., 2006                                        *
  //  *                                           *
  //  *************************************************************
  //
  //  *************************************************************
  //  *  1.1                                                *
  //  *      ,        *
  //  *                *
  //  *    .  ,   *
  //  *    .                        *
  //  *************************************************************
  //
  //  ************************Lite-**************************

uses
  Classes, SysUtils;

const
  //   .
  CYRILLIC_SYMBOLS =
    'Ũ' +
    '';
  //    .
  LATIN_SYMBOLS: array[1..66] of String =
    ('A', 'B', 'V', 'G', 'D', 'E', 'Yo', 'Zh', 'Z', 'I', 'Y', 'K', 'L',
    'M', 'N', 'O', 'P', 'R', 'S', 'T', 'U', 'F', 'H', 'Ts', 'Ch', 'Sh',
    'Chsh', '''''', 'Y', '''', 'E', 'Yu', 'Ya',
    'a', 'b', 'v', 'g', 'd', 'e', 'yo', 'zh', 'z', 'i', 'y', 'k', 'l',
    'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'ts', 'ch', 'sh',
    'chsh', '''''', 'y', '''', 'e', 'yu', 'ya');
  //    .mp3.
  MP3_SEARCH_MASK = '*.mp3';

var
  SourceFile: TSearchRec;
  SourceNames, TransliteratedNames: TStringList;

//  .
function Transliterate(
  //  .
  const Source: String): String;
var
  I, Index: Integer;
begin
  Result := '';
  for I := 1 to Length(Source) do
  begin
    Index := Pos(Source[I], CYRILLIC_SYMBOLS);
    if Index > 0 then
      Result := Result + LATIN_SYMBOLS[Index]
    else
      Result := Result + Source[I];
  end;
end;

//  .
procedure RenameFiles(
  //    .
  const FromList: TStringList;
  //    .
  const ToList: TStringList);
var
  I: Integer;
begin
  for I := 0 to FromList.Count - 1 do
    if not FileExists(ToList[I]) then
      RenameFile(FromList[I], ToList[I]);
end;

begin
  if FindFirst(MP3_SEARCH_MASK, faAnyFile, SourceFile) = 0 then
  try
    SourceNames := TStringList.Create;
    try
      TransliteratedNames := TStringList.Create;
      try
        repeat
          SourceNames.Add(SourceFile.Name);
          TransliteratedNames.Add(Transliterate(SourceFile.Name));
        until FindNext(SourceFile) <> 0;
        RenameFiles(SourceNames, TransliteratedNames);
      finally
        TransliteratedNames.Free;
      end;
    finally
      SourceNames.Free;
    end;
  finally
    FindClose(SourceFile);
  end;
end.